
#include <ggi/ggi.h>
#include <ggi/gwt.h>
#include <stdio.h>

ggi_pixel white, black, red, green, blue;

// Visible or Invalid ...
#define DRAW_REG(x) gwtDrawVisibleRegion(x)


void ClearWindow(gwt_window_t win)
{
  ggi_pixel fg, bg;
  gwtGetGCForeground(win, &fg);
  gwtGetGCBackground(win, &bg);
  gwtSetGCForeground(win, bg);
  gwtFillscreen(win);
  gwtSetGCForeground(win, fg);
  return;
}

#define REDRAW \
	ClearWindow(rootwin); \
	ClearWindow(subwin); \
	ClearWindow(subsubwin); \
	ClearWindow(subsubwin2); \
	DRAW_REG(rootwin); \
	DRAW_REG(subwin); \
	DRAW_REG(subsubwin); \
	DRAW_REG(subsubwin2); \
        gwtDrawBox(subwin, 10, 20, 25, 35); \
        gwtDrawBox(subwin, 155, 150, 35, 20); \
        gwtDrawBox(subsubwin, 10, 10, 15, 20); \
        gwtDrawBox(subsubwin2, 10, 10, 5, 10); \
        gwtDrawLine(subsubwin, 30, 15, 110, 90); \
        gwtPuts(subwin, 25, 80, "GGI Covering"); \
        gwtPutc(subsubwin2, 25, 25, 'R'); \
        gwtPuts(rootwin, 20, 20, "Super-Rod, ... clipped!"); \
	ggiFlush(vis)


int main(int argc, char ** argv)
{
  ggi_event event;
  int x,y;
  int wx=2, wy=2;
  int finished=0;

  ggi_visual_t vis;
  ggi_mode tm;
  gwt_window_t rootwin, subwin, subsubwin;
  gwt_window_t subsubwin2;
  ggi_color col;
  gwt_region_t reg;

  ggiInit();
  gwtInit();
  vis=ggiOpen(NULL);
  gwtAttach(vis);
	
  ggiCheckGraphMode(vis, GT_AUTO, GT_AUTO, GT_AUTO, GT_AUTO, GT_AUTO, &tm);
  ggiSetMode(vis, &tm);

  col.r=col.g=col.b=0x0000;
  black=ggiMapColor(vis, &col);
  col.r=col.g=col.b=0xffff;
  white=ggiMapColor(vis, &col);
  col.g=col.b=0x0000;
  red=ggiMapColor(vis, &col);
  col.r=0x0000;
  col.g=0xffff;
  green=ggiMapColor(vis, &col);
  col.g=0x0000;
  col.b=0xffff;
  blue=ggiMapColor(vis, &col);

  gwtCreateRootWindow(NULL, vis, &rootwin);
  gwtCreateWindow(rootwin, &subwin);
  gwtCreateWindow(subwin, &subsubwin);
  gwtCreateWindow(subwin, &subsubwin2);

  gwtSetFocus(rootwin, subwin);
  gwtSetFocus(subwin, subsubwin);

  gwtMove(subwin, wx, wy);
  gwtResize(subwin, 320, 240);
  gwtMove(subsubwin, wx, wy);
  gwtResize(subsubwin, 160, 120);

  gwtRegionCreate(&reg);
  gwtRegionSetRect(reg, wx+120, wy+160, 60, 60);
  gwtRegionAddRect(reg, wx+120, wy+160, 100, 20);
  gwtSetGeometry(subsubwin2, reg);
  gwtRegionDestroy(reg);

  gwtShow(subwin);
  
  gwtSetGCBackground(rootwin, white);
  gwtSetGCBackground(subwin, red);
  gwtSetGCBackground(subsubwin, green);
  gwtSetGCBackground(subsubwin2, blue);
  gwtSetGCForeground(rootwin, black);
  gwtSetGCForeground(subwin, black);
  gwtSetGCForeground(subsubwin, black);
  gwtSetGCForeground(subsubwin2, black);
	
  do {
    gwt_window_t event_window;
    REDRAW;
    /* TODO: Check why this fails...
       gwtValidate(rootwin);
       gwtValidate(subwin);
       gwtValidate(subsubwin);
       gwtValidate(subsubwin2);
    */
    /* I am not sure that the following is correct...
     * I did a lot of change to event management... -- ortalo (March,2000) */
    gwtEventRead(rootwin, &event, emAll);
    gwtEventLocate(rootwin, &event, &event_window);

    printf("[win=%p]\n", event_window);
    gwtGetPointerLocation(rootwin,&x,&y);

    switch (event.any.type)
      {
      case evKeyPress:
      case evKeyRepeat:
	printf("key (%c) ",event.key.sym);
	fflush(stdout);
	switch (event.key.sym)
	  {
	  case 'q':		/* up*/
	    wy-=16; break;
	  case 'a':		/* down */
	    wy+=16; break;
	  case 'o':		/* left */
	    wx-=16; break;
	  case 'p':		/* right */
	    wx+=16; break;
	  case 'x': case ' ':	case GIIUC_Escape:	/* finish */
	    finished=1; break;
	  case 'l':
	    wx+=16; wy+=16; break;
	  }
	break;
      case evPtrAbsolute:
      case evPtrRelative:
	{
	  printf("pointer_event (x=%d,y=%d) Pointer=%d,%d ",event.pmove.x,event.pmove.y,x,y);
	  fflush(stdout);
	}
	break;
      case evExpose:
	{
	  printf("expose_event (x=%d,y=%d,w=%d,h=%d) ",
		 event.expose.x, event.expose.y,
		 event.expose.w, event.expose.h);
	  fflush(stdout);
	}
	break;
      }
    gwtShow(subsubwin);
    gwtShow(subsubwin2);
    gwtMove(subwin, wx, wy);
    REDRAW;

    gwtMove(subsubwin, wx, wy);
  } while (!finished);

  ggiFlush(vis);

  gwtDestroy(rootwin);	/* closes children first */
  gwtDetach(vis);
  ggiClose(vis);
  gwtExit();
  ggiExit();
  exit(0);
}

